'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.atomTooltipPlacements = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _withIntersectionObserver = require('./hoc/withIntersectionObserver');

var _withIntersectionObserver2 = _interopRequireDefault(_withIntersectionObserver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomTooltip';
var CLASS_INNER = BASE_CLASS + '-inner';
var CLASS_ARROW = BASE_CLASS + '-arrow';
var PREFIX_PLACEMENT = BASE_CLASS + '-';
var CLASS_TARGET = BASE_CLASS + '-target';

var PLACEMENTS = {
  TOP: 'top',
  TOP_START: 'top-start',
  TOP_END: 'top-end',
  RIGHT: 'right',
  RIGHT_START: 'right-start',
  RIGHT_END: 'right-end',
  BOTTOM: 'bottom',
  BOTTOM_START: 'bottom-start',
  BOTTOM_END: 'bottom-end',
  LEFT: 'left',
  LEFT_START: 'left-start',
  LEFT_END: 'left-end'
};

var AtomTooltip = function (_Component) {
  (0, _inherits3.default)(AtomTooltip, _Component);

  function AtomTooltip() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomTooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomTooltip.__proto__ || (0, _getPrototypeOf2.default)(AtomTooltip)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isOpen: false }, _this.preventNonTouchEvents = false, _this.hasTouchEnded = false, _this.touchTimer = null, _this.onClickTarget = null, _this.title = null, _this.refTooltip = _react2.default.createRef(), _this.refTarget = _react2.default.createRef(), _this.handleContextMenu = function (e) {
      e.preventDefault();
      e.stopPropagation();
      return false;
    }, _this.handleClickOutsideElement = function (e) {
      var isOpen = _this.state.isOpen;

      var target = _this.refTarget.current;
      if (isOpen) {
        var tooltipDom = _this.refTooltip.current;
        var isOutside = tooltipDom && !tooltipDom.contains(e.target);
        var isNotTarget = target && !target.contains(e.target);
        if (isOutside && isNotTarget) _this.toggle(false);
      }
    }, _this.handleTouchStart = function (e) {
      var longPressTime = _this.props.longPressTime;

      _this.preventNonTouchEvents = true;
      _this.hasTouchEnded = false;
      clearTimeout(_this.touchTimer);
      _this.touchTimer = setTimeout(function () {
        if (!_this.hasTouchEnded) {
          _this.setState({
            isOpen: !_this.state.isOpen
          });
        }
        _this.preventNonTouchEvents = false;
        _this.hasTouchEnded = false;
      }, longPressTime);
      return false;
    }, _this.handleTouchEnd = function (e) {
      if (!_this.preventNonTouchEvents) _this.handleStopPropagation(e);
      _this.hasTouchEnded = true;
      clearTimeout(_this.touchTimer);
    }, _this.handleStopPropagation = function (e) {
      e.preventDefault();
      e.stopPropagation();
      return false;
    }, _this.handleToggleOnNormalTarget = function (e) {
      var type = e.type;

      var isValidTrigger = ['click', 'focusin', 'mouseover', 'mouseout'].includes(type);
      if (type === 'touchstart') _this.hasTouchEnded = false;
      if (type === 'touchend') _this.hasTouchEnded = true;
      if (_this.hasTouchEnded && ['focusin', 'mouseover'].includes(type)) {
        _this.handleStopPropagation(e);
      }
      if (isValidTrigger) _this.toggle();
    }, _this.handleToggleOnCallToActionTarget = function (e) {
      var type = e.type;

      if (type === 'touchstart') _this.handleTouchStart(e);
      if (type === 'touchend') _this.handleTouchEnd(e);
      if (!_this.preventNonTouchEvents) _this.toggle();
    }, _this.toggle = function (value) {
      var isOpen = value || !_this.state.isOpen;
      _this.setState({ isOpen: isOpen });
    }, _this.handleToggle = function (e) {
      if (_this.onClickTarget) _this.handleToggleOnCallToActionTarget(e);else _this.handleToggleOnNormalTarget(e);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomTooltip, [{
    key: 'extendChildren',
    value: function extendChildren() {
      var _this2 = this;

      var children = this.props.children; // eslint-disable-line react/prop-types

      var ref = this.refTarget;
      var className = CLASS_TARGET;
      var onTouchEnd = this.handleToggle;

      var childrenOnly = _react2.default.Children.only(children);

      return _react2.default.Children.map(childrenOnly, function (child) {
        _this2.onClickTarget = child.props.onClick;
        _this2.title = child.props.title;
        return _react2.default.cloneElement(child, {
          ref: ref,
          className: className,
          onTouchEnd: onTouchEnd
        });
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      var target = this.refTarget.current;
      this.props.innerRef(target);['click', 'touchend'].forEach(function (event) {
        return window.addEventListener(event, _this3.handleClickOutsideElement);
      });
      target.oncontextmenu = this.handleContextMenu;
      target.addEventListener('mouseover', this.disableTitle);
      target.addEventListener('mouseout', this.restoreTitle);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this4 = this;

      var target = this.refTarget.current;
      clearTimeout(this.touchTimer);['click', 'touchend'].forEach(function (event) {
        return window.removeEventListener(event, _this4.handleClickOutsideElement);
      });
      target.removeEventListener('mouseover', this.disableTitle);
      target.removeEventListener('mouseout', this.restoreTitle);
    }
  }, {
    key: 'disableTitle',
    value: function disableTitle(e) {
      this.dataset.title = this.title;
      this.title = '';
    }
  }, {
    key: 'restoreTitle',
    value: function restoreTitle(e) {
      this.title = this.dataset.title;
    }

    /**
     * This function is executed when target doesn't have an `onClick` prop (normal targets)
     * this logic assures that only the proper events triggers the tooltip
     */


    /**
     * This function is executed when target DOES have an `onClick` prop ('call-to-action' targets)
     * this logic assures that only the proper events triggers the tooltip
     */

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          hideArrow = _props.hideArrow,
          HtmlContent = _props.content,
          delay = _props.delay,
          autohide = _props.autohide,
          placement = _props.placement; // eslint-disable-line react/prop-types

      var target = this.refTarget.current;
      var restrictedProps = {
        hideArrow: hideArrow,
        target: target,
        delay: delay,
        autohide: autohide,
        placement: placement
      };
      return _react2.default.createElement(
        _react.Fragment,
        null,
        this.extendChildren(),
        target && _react2.default.createElement(
          _reactstrap.Tooltip,
          (0, _extends3.default)({}, restrictedProps, {
            isOpen: this.state.isOpen,
            toggle: this.handleToggle,
            className: BASE_CLASS,
            innerClassName: CLASS_INNER,
            arrowClassName: CLASS_ARROW,
            placementPrefix: PREFIX_PLACEMENT,
            innerRef: this.refTooltip,
            offset: 'auto,4px'
          }),
          HtmlContent ? _react2.default.createElement(HtmlContent, null) : this.title
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (!nextProps.isVisible && prevState.isOpen) {
        return { isOpen: false };
      }
      return null;
    }
  }]);
  return AtomTooltip;
}(_react.Component);

AtomTooltip.displayName = 'AtomTooltip';

AtomTooltip.defaultProps = {
  isVisible: true,
  longPressTime: 1000
};

AtomTooltip.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Wether to show arrow or not. */
  hideArrow: _propTypes2.default.bool,

  /** Optionally override show/hide delays. Default  → { show: 0, hide: 250 } */
  delay: _propTypes2.default.oneOfType([_propTypes2.default.shape({
    show: _propTypes2.default.number,
    hide: _propTypes2.default.number
  }), _propTypes2.default.number]),

  /** optionally hide tooltip when hovering over tooltip content. Default → true */
  autohide: _propTypes2.default.bool,

  /** Tooltip and arrow position */
  placement: _propTypes2.default.oneOf((0, _values2.default)(PLACEMENTS)),

  /** True if the target is inside the viewport */
  isVisible: _propTypes2.default.bool,

  /** HTML (component) to be displayed on the Tooltip */
  content: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** Custom ref handler that will be assigned to the "target" element */
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string, _propTypes2.default.object]),

  /** Time in miliseconds for longpress duration */
  longPressTime: _propTypes2.default.number
} : {} : {};

exports.default = (0, _withIntersectionObserver2.default)(AtomTooltip);
exports.atomTooltipPlacements = PLACEMENTS;